/*
 * Created by SharpDevelop.
 * User: gorina_admin
 * Date: 7/21/2018
 * Time: 10:00 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using Autodesk.Revit.UI;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI.Selection;
using Autodesk.Revit.DB.Architecture;  //some elements (rooms, stairs, railings)are only defined in architecture
using System.Collections.Generic;
using System.Linq;
using System.Collections;
using System.IO; //added to stream data to files
using System.Text; //added to create string builder
using Autodesk.Revit.Attributes; //added for families
using Microsoft.CSharp; //added for forms
using Microsoft.Office.Interop.Excel;
using System.Reflection; //needed for excel

namespace AU2018
///// <summary>
/// use as is,  
/// Helen.Gorina@perkinswill.com
/// </summary>

	
	
{
    [Autodesk.Revit.Attributes.Transaction(Autodesk.Revit.Attributes.TransactionMode.Manual)]
    [Autodesk.Revit.DB.Macros.AddInId("9EADCEF1-0966-4D94-8BF0-292D81D53A8C")]
	public partial class ThisApplication
	{
		private void Module_Startup(object sender, EventArgs e)
		{

		}

		private void Module_Shutdown(object sender, EventArgs e)
		{

		}

		#region Revit Macros generated code
		private void InternalStartup()
		{
			this.Startup += new System.EventHandler(Module_Startup);
			this.Shutdown += new System.EventHandler(Module_Shutdown);
		}
		#endregion
		public void ReporterFull()
		{
			///////////////////////////////////////////////////////////////////////////////////////////////////
			/// Version 9 Helen Gorina 7-21-2018
			/// Helen.Gorina@perkinswill.com
			/// 
			/// Updated for Revit 2019,fixed some deprecated properties, need to add background pattern report to filled region
			/// 
			/// Updated for Revit 2018, 
			/// added many new tabs
			/// 
			/// catching an exception where filled region does not have a pattern assigned
			/// 
			/// functionality- upon triggering:
			/// reports various styles  and other stuff from the project into excel file
			/// Notes:
			///  Outputs to "c:\\temp\\PWMacro\\FullReport";
			/// Revit file has to be saved!!!
			/// 
			/// ///////////////////////////////////////////////////////////////////////////////////////////////
			
			string strDir ="c:\\temp\\PWMacro\\FullReport";
			
			
			// string strFile= "FullReport"; nedd current file name
			
			System.IO.Directory.CreateDirectory(strDir); //need folderto be ready to accept
			
			
			//List <string> headerList= new List<string>(); // to hold list of columns for each sheet
			List <string> outRow= new List<string>();// to hold one data row
			//List <string> curRow= new List<string>();// to hold temp for one row
			List<List<string>> outputRows= new List<List<string>>(); //to hold multple rows of data
			
			
			Document doc = ActiveUIDocument.Document;
			StringBuilder sb = new StringBuilder();
			
			string pathFile= ActiveUIDocument.Document.PathName;
			string result = Path.GetFileName(pathFile);
			string strFile=result.Substring(0, result.Length-4);
			object oOpt = System.Reflection.Missing.Value; //for optional arguments
			Application excelApp=new Application();
			Workbook workbook =excelApp.Workbooks.Add(Missing.Value);
			#region subcategories
			/// /////////////// subcategories//////////////////////////////////////////////////////////////////////////////////////////
			
			
			Categories categories = doc.Settings.Categories;
			outputRows.Clear();
			
			outRow.Clear();
			
			int n = categories.Size;
			//List<string> ls = new List<string>();// to keep all each category in a separate line
			outRow.Add("name");
			outRow.Add("parent");
			outRow.Add("ID");
			//outRow.Add("number of subcategories");
			outRow.Add("is read only");
			outRow.Add("AllowsBoundParameters");
			outRow.Add("CanAddSubcategory");
			outRow.Add("HasMaterialQuantities");
			outRow.Add("isCuttable");
			//outRow.Add("Material");
			
			outputRows.Add(outRow);
			
			// find  all top level categories
			foreach( Category cat in categories )
			{

//				// process subcategories if exist
				int nn=cat.SubCategories.Size;
				if (nn>0) {
					
					foreach( Category subC in cat.SubCategories )
						
					{
						List <string> curRow= new List<string>();// to hold temp for one row
						if (subC.Id.IntegerValue>0)//only need positive IDs
						{
							curRow.Add(subC.Parent.Name); //always has parent
							curRow.Add(subC.Name);
							curRow.Add(subC.Id.ToString());
							curRow.Add(subC.SubCategories.Size.ToString());
							curRow.Add(subC.IsReadOnly.ToString());
							curRow.Add(subC.AllowsBoundParameters.ToString());
							curRow.Add(subC.CanAddSubcategory.ToString());
							curRow.Add(subC.HasMaterialQuantities.ToString());
							curRow.Add(subC.IsCuttable.ToString());
							outputRows.Add(curRow);
						}
					}
				}
			}

			///excelApp.Worksheets.Add(); do not need to add first
			
			Worksheet worksheet7 = (Worksheet)workbook.ActiveSheet;
			worksheet7.Name="User_SubCategories";
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet7);
			
			#endregion
			#region LinePatterns
			/// ///////////////// Line patterns//////////////////////////////////////////////////////////////////////////////////////////////////////
			
			
			var  colLinePat = new FilteredElementCollector(doc);
			colLinePat.OfClass(typeof(LinePatternElement)).ToList();// get all line patterns
			
			
			
			outputRows.Clear();
			outRow.Clear();
			foreach (LinePatternElement linePatElement in colLinePat)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				
				curRow.Add(linePatElement.Name);
				
				IList <LinePatternSegment> seglist =(linePatElement.GetLinePattern().GetSegments());
				
				foreach (LinePatternSegment seg in seglist) {
					string segtype=seg.Type.ToString();
					curRow.Add(segtype);
					string segtlengh=seg.Length.ToString();
					curRow.Add(segtlengh);
					
				}
				outputRows.Add(curRow);
			}
			
			
			string filename= @"C:\temp\PWMacro\FullReport\"+ strFile;
			if (File.Exists(filename+".xls")) {
				File.Delete(filename+".xls");
			}
			excelApp.Worksheets.Add();
			Worksheet worksheet = (Worksheet)workbook.ActiveSheet;
			worksheet.Name="LinePatterns";

			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet);
			#endregion
			#region Linestyles
			/// <linestyles begin>!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet1 = (Worksheet)workbook.ActiveSheet;
			worksheet1.Name="LineStyles";
			
			Category c = doc.Settings.Categories.get_Item(BuiltInCategory.OST_Lines );
			
			
			foreach( Category subC in c.SubCategories )
			{
				
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(subC.Name);
				outputRows.Add(curRow);
			}
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet1);
			
			/// </linestyles end>
			#endregion
			#region FillPatterns
			/// <fill Patterns>!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			/// 
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet2 = (Worksheet)workbook.ActiveSheet;
			worksheet2.Name="Fill Patterns";
			var  colFillPat = new FilteredElementCollector(doc);
			colFillPat.OfClass(typeof(FillPatternElement)).ToList();// get all fill patterns
			
			outRow.Clear();
			outRow.Add("ElementName");
			outRow.Add("PatternName");
			outRow.Add("HostOrientation");
			outRow.Add("Target");
			outputRows.Add(outRow);// for header
			
			foreach (FillPatternElement fillPatElement in colFillPat)
			{
				
				
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(fillPatElement.Name);
				FillPattern fp= fillPatElement.GetFillPattern();
				curRow.Add(fp.Name);
				curRow.Add(fp.HostOrientation.ToString());
				curRow.Add(fp.Target.ToString());
				outputRows.Add(curRow);
				
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet2);
			#endregion
			#region DimStyles
			/// <dimstyles>!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			/// 
			///
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet3 = (Worksheet)workbook.ActiveSheet;
			worksheet3.Name="DimStyles";
			var  coldimstyles = new FilteredElementCollector(doc);
			coldimstyles.OfClass(typeof(DimensionType)).ToList();// get all dimtypes
			
			foreach (DimensionType  dimtype in coldimstyles)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(dimtype.Name);
				foreach (Autodesk.Revit.DB.Parameter para in dimtype.GetOrderedParameters())
				{
					string defName = para.Definition.Name;
					// Use different method to get parameter data according to the storage type
					switch (para.StorageType)
					{
						case StorageType.Double:
							//covert the number into units
							
							curRow.Add(defName+ ":" +para.AsValueString());
							
							break;
						case StorageType.ElementId:
							//find out the name of the element
							ElementId id = para.AsElementId();
							if (id.IntegerValue >= 0)
							{
								curRow.Add(defName + ":" +doc.GetElement(id).Name);
								
							}
							else
							{
								curRow.Add(defName + ":" +id.ToString());
							}
							break;
						case StorageType.Integer:
							if (ParameterType.YesNo == para.Definition.ParameterType)
							{
								if (para.AsInteger() == 0)
								{
									curRow.Add(defName+ ":" +"False");
								}
								else
								{
									curRow.Add(defName+ ":" +"True");
								}
							}
							else
							{
								curRow.Add(defName+ ":" +para.AsInteger().ToString());
							}
							break;
						case StorageType.String:
							curRow.Add(defName+ ":" +para.AsString());
							break;
						default:
							curRow.Add("Unexposed parameter");
							break;
					}
					
				}
				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet3);/// </dimstyles>
			#endregion
			#region TextStyles
			
			/// <textstyles>/!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet4 = (Worksheet)workbook.ActiveSheet;
			worksheet4.Name="TextStyles";
			var  coltextstyles = new FilteredElementCollector(doc);
			coltextstyles.OfClass(typeof(TextNoteType)).ToList();// get all text styles
			
			
			foreach (TextNoteType  textNtype in coltextstyles)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(textNtype.Name);
				foreach (Autodesk.Revit.DB.Parameter para in textNtype.GetOrderedParameters())
				{
					//sb.AppendLine(GetParameterInformation(para, doc));
					string defName = para.Definition.Name;
					// Use different method to get parameter data according to the storage type
					
					{
						switch (para.StorageType) {
							case StorageType.Double:
								curRow.Add(defName + ":" + para.AsValueString());
								break;
							case StorageType.ElementId:
								ElementId id = para.AsElementId();
								if (id.IntegerValue >= 0) {
									curRow.Add(defName + ":" + doc.GetElement(id).Name);
								} else {
									curRow.Add(defName + ":" + id.ToString());
								}
								break;
							case StorageType.Integer:
								if (ParameterType.YesNo == para.Definition.ParameterType) {
									if (para.AsInteger() == 0) {
										curRow.Add(defName + ":" + "False");
									} else {
										curRow.Add(defName + ":" + "True");
									}
								} else {
									curRow.Add(defName + ":" + para.AsInteger().ToString());
								}
								break;
							case StorageType.String:
								curRow.Add(defName + ":" + para.AsString());
								break;
							default:
								curRow.Add("Unexposed parameter");
								break;
						}
					}

					
				}
				outputRows.Add(curRow);
				
				ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet4);/// <textstypes
			}
			#endregion
			#region ArrowheadsAll
			
			/// <Arrowheads>all  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			{
				
				outputRows.Clear();
				excelApp.Worksheets.Add();
				Worksheet worksheet5 = (Worksheet)workbook.ActiveSheet;
				worksheet5.Name="ArrowheadsAll ";
				
				
				
				// create a collection of all the Arrowhead types
				ElementId id = new ElementId(BuiltInParameter.ALL_MODEL_FAMILY_NAME);
				ParameterValueProvider provider = new ParameterValueProvider(id);
				FilterStringRuleEvaluator evaluator = new FilterStringEquals();
				FilterRule rule = new FilterStringRule(provider, evaluator, "Arrowhead", false);
				ElementParameterFilter filter = new ElementParameterFilter(rule);
				FilteredElementCollector collector2 = new FilteredElementCollector(doc).OfClass(typeof(ElementType)).WherePasses(filter);
				
				//ElementId arrowheadId = null;
				// loop through the collection of Arrowhead types and get the Id of a specific one
				foreach(ElementId eid in collector2.ToElementIds())
				{
					
					List <string> curRow= new List<string>();// to hold temp for one row
					curRow.Add(doc.GetElement(eid).Name+", ");
					
					/// <for future cleanup>
					/// //             if(doc.GetElement(eid).Name == "Arrow Filled 30 Degree") //change the name to the arrowhead type you want to use
					//                {
					//                    arrowheadId = eid;
					//                }
					/// </fur future cleanup>
					outputRows.Add(curRow);
					
				}
				
				ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet5);/// <arrowheads
				
				#endregion
			#region	ArrowheadsIn Families
				/// arrowheads per family!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				outputRows.Clear();
				excelApp.Worksheets.Add();
				Worksheet worksheet6 = (Worksheet)workbook.ActiveSheet;
				worksheet6.Name="ArrowheadsInFamilies ";

				BuiltInParameter arrowParamIndex=BuiltInParameter.LEADER_ARROWHEAD; //BuiltInParameter inparameters in frmFamiliesToProcess are tricky to get
				
				// create a collection of all families
				
				List<Family> families = new List<Family>(new FilteredElementCollector(doc).OfClass(typeof(Family)).Cast<Family>());
				
				foreach(Family f in families)
				{
					
					string famname=f.Name;
					
					ISet<ElementId> familySymbolIds = f.GetFamilySymbolIds(); //get all types
					if (familySymbolIds.Count == 0)
					{
						//do nothing
						
					}
					else
						
					{
						// Get family symbols which is contained in this family
						
						foreach (ElementId curID in familySymbolIds)
						{
							List <string> curRow= new List<string>();// to hold temp for one row
							curRow.Add(famname);
							FamilySymbol familySymbol = f.Document.GetElement(curID) as FamilySymbol;
							
							{
								
								string typename=familySymbol.Name;
								curRow.Add(typename);
								
								try //if arrow param existis
								{
									Autodesk.Revit.DB.Parameter curpar=familySymbol.get_Parameter(arrowParamIndex);
									string paramval=curpar.AsValueString();
									
									curRow.Add(paramval);
								}
								catch
								{
									curRow.Add("N/A");
								}
							}
							outputRows.Add(curRow);				}
					}
					
				}
				ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet6);//arrowheads in families
			}
			#endregion
			#region ProjectParams
//				/// project parameters and their bindings!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet8 = (Worksheet)workbook.ActiveSheet;
			worksheet8.Name="Project_parameters";
			BindingMap bindings = doc.ParameterBindings;
			int nb = bindings.Size;
			if (0 < nb)

			{
				// Loop all Binding Definitions
				// 
				// For multiple categories, there is really one
				// pair per each category, even though the
				// Definitions are the same...
				DefinitionBindingMapIterator it= bindings.ForwardIterator();
				
				while (it.MoveNext())
				{
					List <string> curRow= new List<string>();// to hold temp for one row
					curRow.Clear();
					Definition d = it.Key as Definition; //get definition- it is a key in iterator!
					
					/// also need to cast as shared parameter, and if null, it is not shared
					/// 
					
					
					var definition = (InternalDefinition) it.Key;
					var sharedParameterElement = doc.GetElement(definition.Id ) as SharedParameterElement;

					
					ElementBinding b = it.Current as ElementBinding;		//get binding - it is current element in iterator
					
					
					///Autodesk.Revit.DB.Parameter par= it.Current as Autodesk.Revit.DB.Parameter;
					
					///problem: it shows null binding does not cast into parameter...
					
					/// need to get to parameter collector and reference by name - see below.
					/// 
					/// then retrieve parameter value and data type
					/// 
					
					
					
					CategorySet catSet= b.Categories;
					curRow.Add(d.Name);
					if( sharedParameterElement == null )
					{
						curRow.Add("NotShared");
					}
					else
					{
						curRow.Add(sharedParameterElement.GuidValue.ToString());
					}
					curRow.Add(d.ParameterGroup.ToString());
					curRow.Add(d.ParameterType.ToString());
					//String parainfo=GetParameterInformation(par,doc);
					//curRow.Add(parainfo);
					if (b.GetType() != typeof( InstanceBinding )) {curRow.Add("Type");}
					
					else{curRow.Add("Instance"); }
					
					sb.Clear();
					foreach( Category ctg in catSet )
					{
						
						sb.Append(ctg.Name+", ");
						//curRow.Add(sb.ToString());
					}
					curRow.Add(sb.ToString());
					
					outRow=curRow;
//					if (outRow=null) {
//					outRow="Empty"	;
//					}
					outputRows.Add(curRow);
					
				}

			}
			else // no project parameters
			{
				outRow.Add("Empty");
				outputRows.Add(outRow);	
			}

			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet8);//arrowheads in families
			#endregion
			#region ViewTemplates
//				/// view templates   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet9 = (Worksheet)workbook.ActiveSheet;
			worksheet9.Name="view_templates";
			FilteredElementCollector collectorViews = new FilteredElementCollector(doc);
			collectorViews.OfClass(typeof(View)).ToElements();// get all views
			foreach (View view in collectorViews)
			{
				if (view.IsTemplate)
				{
					List <string> curRow= new List<string>();// to hold temp for one row
					curRow.Clear();
					curRow.Add(view.Id.ToString());
					curRow.Add(view.Name);
					curRow.Add(view.Scale.ToString());
					curRow.Add(view.ViewType.ToString());
					curRow.Add(view.ToString());
					
					outRow=curRow;
					
					outputRows.Add(curRow);
				}
				
			}
			if (outputRows.Count<1) {  // to catch no template situation
				outRow.Add("no view templates found");
				outputRows.Add(outRow);
			}
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet9);
			
			#endregion
			#region Worksets


			//	worksetss   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet10 = (Worksheet)workbook.ActiveSheet;
			worksheet10.Name="worksets";
			
			if (doc.IsWorkshared)
			{
				FilteredWorksetCollector coll = new FilteredWorksetCollector(doc);
				// want to filter them...
				coll.OfKind(WorksetKind.UserWorkset);
				IList<Workset> worksets = coll.ToWorksets();
				// get information for each workset
				int count = worksets.Count;
				foreach (Workset workset in worksets)
				{
					List <string> curRow= new List<string>();// to hold temp for one row
					curRow.Clear();
					curRow.Add(workset.Name);
					curRow.Add(workset.Id.ToString());
					curRow.Add(workset.Owner);
					curRow.Add(workset.Kind.ToString());
					curRow.Add(workset.IsDefaultWorkset.ToString());
					curRow.Add( workset.IsEditable.ToString());
					curRow.Add(workset.IsOpen.ToString());
					curRow.Add(workset.IsVisibleByDefault.ToString());
					
					outRow=curRow;
					outputRows.Add(curRow);

					if (0 == --count)
						break;
				}
			}
			else
			{//// workshared.Append("not workshared"); to change!
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				curRow.Add(" not workshared");
				outRow=curRow;
				outputRows.Add(curRow);
			}
			
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet10);//arrowheads in families
			#endregion
			#region	legends

//				/// legend  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet11 = (Worksheet)workbook.ActiveSheet;
			worksheet11.Name="legends";
//			FilteredElementCollector collectorViews = new FilteredElementCollector(doc); /////alreadt have then
//			collectorViews.OfClass(typeof(View)).ToElements();// get all views
			foreach (View view in collectorViews)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				if (!view.IsTemplate)
				{
					
					
					if (view.ViewType==ViewType.Legend) {
						
						curRow.Add(view.ViewType.ToString());
						curRow.Add(view.Name);
						curRow.Add(view.Id.ToString());
						curRow.Add(view.Scale.ToString());
						curRow.Add(view.DetailLevel.ToString());
						//curRow.Add(view.CreatedPhaseId.ToString());
						
						outputRows.Add(curRow);
						
					}
					
				}
				
				
			}
			if (outputRows.Count==0) {
				outRow.Add("No legend views found. What you call keynote legends are in fact schedules - look for them there");
				outputRows.Add(outRow);}
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet11);
			#endregion
			#region Schedules

//				/// schedules !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet12 = (Worksheet)workbook.ActiveSheet;
			worksheet12.Name="schedules";
			//	FilteredElementCollector collectorViews = new FilteredElementCollector(doc); /////alreadt have then
			//	collectorViews.OfClass(typeof(View)).ToElements();// get all views
			foreach (View view in collectorViews)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				if (!view.IsTemplate)
				{
					
					if (view.ViewType== ViewType.Schedule) {
						
						curRow.Add(view.ViewType.ToString());
						curRow.Add(view.Name);
						curRow.Add(view.Id.ToString());
						//curRow.Add(view.Scale.ToString());
						//curRow.Add(view.DetailLevel.ToString());
						if (view.ViewTemplateId.IntegerValue>0)
						{
							View curTemplate= doc.GetElement(view.ViewTemplateId) as View;
							curRow.Add(curTemplate.Name);
						}
						
						outRow=curRow;
						outputRows.Add(curRow);
						
					}
				}
				
			}
			if (outputRows.Count<1) { // add condition where no schedules
				outRow.Add("No schedules found");
				outputRows.Add(outRow);
			}
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet12);
			#endregion
			#region Phases

//				/// phases !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet13 = (Worksheet)workbook.ActiveSheet;
			worksheet13.Name="phases";
			PhaseArray phases = doc.Phases;
			// get all phases
			

			if (0 != phases.Size)
			{
				
				foreach (Phase phase in phases)
				{
					List <string> curRow= new List<string>();// to hold temp for one row
					curRow.Clear();
					
					curRow.Add(phase.Name);
					BuiltInParameter paraPhaseNumber = BuiltInParameter.PHASE_SEQUENCE_NUMBER;
					Autodesk.Revit.DB.Parameter par = phase.get_Parameter(paraPhaseNumber);

					curRow.Add(par.AsValueString());
					//curRow.Add(phase.);
					
					outRow=curRow;
					outputRows.Add(curRow);
				}
			}
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet13);
			#endregion
			#region PhaseFilters

//				/// phases filters !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet14 = (Worksheet)workbook.ActiveSheet;
			worksheet14.Name="phase filters";
			FilteredElementCollector phaseF = new FilteredElementCollector(doc);
			phaseF.OfClass(typeof(PhaseFilter)).ToElements();// get all phase filters
			
			foreach (PhaseFilter phf in phaseF)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(phf.Name);
//				BuiltInParameter paraPhaseNumber = BuiltInParameter.PHASE_SEQUENCE_NUMBER;
//				Autodesk.Revit.DB.Parameter par = phase.get_Parameter(paraPhaseNumber);

//				curRow.Add(par.AsValueString());
				//curRow.Add(phase.);
				
				outRow=curRow;
				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet14);
			#endregion
			#region ViewFilters
			
			//				/// View filters !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet15 = (Worksheet)workbook.ActiveSheet;
			worksheet15.Name="View filters";
			FilteredElementCollector viewF = new FilteredElementCollector(doc);
			viewF.OfClass(typeof(FilterElement)).ToElements();// get all phase filters
			
			foreach (FilterElement fe in viewF)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(fe.Name);
//				BuiltInParameter paraPhaseNumber = BuiltInParameter.PHASE_SEQUENCE_NUMBER;
//				Autodesk.Revit.DB.Parameter par = phase.get_Parameter(paraPhaseNumber);

//				curRow.Add(par.AsValueString());
				//curRow.Add(phase.);
				
				outRow=curRow;
				outputRows.Add(curRow);
			}
			
			if (outputRows.Count<1) {
				outRow.Add("No View filters found");
				outputRows.Add(outRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet15);
			#endregion
			#region Levels

			////////////////				/// levels !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet16 = (Worksheet)workbook.ActiveSheet;
			worksheet16.Name="levels";
			FilteredElementCollector colLevels = new FilteredElementCollector(doc);
			colLevels.OfClass(typeof(Level)).ToElements();// get all levels
			
			foreach (Level level in colLevels)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(level.Name);

				curRow.Add(level.Elevation.ToString());
				outRow=curRow;
				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet16);
			#endregion
			#region Area Schemes

//				/// Area Schemes !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet17 = (Worksheet)workbook.ActiveSheet;
			worksheet17.Name="Area Schemes";
			FilteredElementCollector colAS = new FilteredElementCollector(doc);
			colAS.OfClass(typeof(AreaScheme)).ToElements();// get all area schemes
			
			foreach (AreaScheme ArS in colAS)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(ArS.Name);

				
				outRow=curRow;
				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet17);
			#endregion
			#region Materials

//				/// Materials !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet18 = (Worksheet)workbook.ActiveSheet;
			worksheet18.Name="Materials";
			FilteredElementCollector colMat = new FilteredElementCollector(doc);
			colMat.OfClass(typeof(Material)).ToElements();// get all area schemes
			
			foreach (Material mat in colMat)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(mat.Name);

				outRow=curRow;
				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet18);
			#endregion
			#region Walls

			/// walls !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet19 = (Worksheet)workbook.ActiveSheet;
			worksheet19.Name="walls";
			
			FilteredElementCollector wallTypes= new FilteredElementCollector(doc).OfClass(typeof(WallType));
			
			
			
			
			//SortedList<int,string> listLayers = new SortedList<int,string>();
			
			string strHeader= "Wall Type! Wall Width Inch!Wall Kind!Function!End wrap! InsertWrap! LayerID!Layermaterial!Layer Function!Layer thickness in Inches! cap flag";
			List<string> header = strHeader.Split('!').ToList<string>();
			
			outputRows.Add(header);
			foreach (WallType wt in wallTypes) {
				//listLayers.Clear();
				
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(wt.Name);
				curRow.Add((wt.Width*12).ToString());
				curRow.Add(wt.FamilyName);
				curRow.Add(wt.Function.ToString());
				//curRow.Add(wt.Kind.ToString()); family name covers that
				switch (wt.Kind)
				{
					case WallKind.Stacked :
						outRow=curRow;
						outputRows.Add(curRow);
						break;// no additional information extracted
					case WallKind.Curtain :
						outRow=curRow;
						outputRows.Add(curRow);
						break;// no additional information extracted
					case WallKind.Basic :
						// need to extract layer information for reglar walls and will need multiple rows and sorting
						SortedList<int,List<string>> outputRowsLayers= new SortedList<int,List<string>>(); //to hold multple rows of data for Layers and be able to sort by integer later
						outputRowsLayers.Clear();
						List<string> core1 = new List<string>();
						List<string> core2 = new List<string>();
						core1.Clear();
						core2.Clear();
						CompoundStructure comStruct= wt.GetCompoundStructure();
						
						curRow.Add(comStruct.EndCap.ToString());
						curRow.Add(comStruct.OpeningWrapping.ToString());
						
						
						// Get the category OST_Walls default Material;	// use if that layer's default Material is <By Category>
						Categories allCategories = doc.Settings.Categories;
						Category wallCategory = allCategories.get_Item(BuiltInCategory.OST_Walls);
						Autodesk.Revit.DB.Material wallMaterial = wallCategory.Material; ////null???????????????  this happens when wall category does not have a material assigned
						
						int firstCore=comStruct.GetFirstCoreLayerIndex();//index of first core - from exterior
						int lastCore=comStruct.GetLastCoreLayerIndex();//index of last core - from exterior
						int sandwichID=0;
						///check for if it is just one layer within the core
						/// 


						core1=curRow.ToList();/// addignmebt and additions do not work because curRow value changes later, so use ToList
						core1.Add((firstCore+1).ToString());
						core1.Add("Core Exterior");
						outputRowsLayers.Add(firstCore+1,core1);

						core2=curRow.ToList();
						core2.Add((lastCore+3).ToString());
						core2.Add("Core Interior");

						outputRowsLayers.Add(lastCore+3,core2);

						///// Going into layers
						//SortedList <int,string> tmpListRow= new SortedList<int,string>();// to hold temp for all layers
						
						//List <string> tmpRow= new List<string>();// to hold temp for one layer
						foreach (CompoundStructureLayer structLayer in comStruct.GetLayers())
						{
							List <string> tmpRow= new List<string>();// to hold temp for one layer
							tmpRow.Clear();
							/// figure out sandwich layer number and cores
							
							tmpRow.AddRange(curRow);
							
							
							if (structLayer.LayerId<firstCore)
							{
								sandwichID=structLayer.LayerId+1;
								
							}
							
							else
							{
								if (structLayer.LayerId>=firstCore)
								{
									if (!(structLayer.LayerId>lastCore))//between cores
									{
										sandwichID=structLayer.LayerId+2;
										//sbLay.Append(sandwichID.ToString()+" !");
										
									}
									else{//outside last core
										sandwichID=structLayer.LayerId+3;
//

									}
								}
							}
							tmpRow.Add(sandwichID.ToString());
							
							
							// Material of its Category, need to indicate that it came from category!!!!!
							Autodesk.Revit.DB.Material layerMaterial =doc.GetElement(structLayer.MaterialId) as Material;  //this is fine if material is assigned explicitly
							
							
							if (null == layerMaterial)//not assigned- by category, get material from wall category
							{
								// CompoundStructureLayer's default Material is its SubCategory
								layerMaterial = wallMaterial;
							}
							
							if (null == layerMaterial)//still Null if wall material is not assigned!!!!
							{
								tmpRow.Add("by category-not defined");
							}
							else{ tmpRow.Add(layerMaterial.Name);
							}
							
							tmpRow.Add(structLayer.Function.ToString());
							tmpRow.Add((structLayer.Width*12).ToString());
							tmpRow.Add((structLayer.LayerCapFlag).ToString());
							
							//curRow.AddRange(tmpRow);
							
							outputRowsLayers.Add(sandwichID,tmpRow);
							
							
						}//end of layers
						
						outputRows.AddRange(outputRowsLayers.Values.ToList());
						
						break;
					default:
						
						break;
				}// end of basic wall case
				
			}//end of wall collection
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet19);
			#endregion
			#region Ceilings


			/// ceilings!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet20 = (Worksheet)workbook.ActiveSheet;
			worksheet20.Name="ceilings";
			
			FilteredElementCollector ceilingTypes= new FilteredElementCollector(doc).OfClass(typeof(CeilingType));
			
			//SortedList<int,string> listLayers = new SortedList<int,string>();
			
			string strCeilHeader= "ceiling Type! ceiling Kind!LayerID!Layermaterial!Layer Function!Layer thickness in Inches! layer wrap flag";
			List<string> Cheader = strCeilHeader.Split('!').ToList<string>();
			outputRows.Add(Cheader);
			
			foreach (CeilingType ct in ceilingTypes) {
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				curRow.Add(ct.FamilyName);
				curRow.Add(ct.Name);
				//curRow.Add((ct.Width*12).ToString()); // only exists in compouund structure exists
				
				
				if (ct.FamilyName=="Compound Ceiling")
				{
					
					Categories allCategories = doc.Settings.Categories;
					Category CeilingCategory = allCategories.get_Item(BuiltInCategory.OST_Ceilings);
					Autodesk.Revit.DB.Material CeilingMaterial = CeilingCategory.Material; ////null???????????????  this happens when wall category doe not have a material assigned
					
					SortedList<int,List<string>> outputRowsLayers= new SortedList<int,List<string>>(); //to hold multple rows of data for Layers and be able to sort by integer later
					outputRowsLayers.Clear();
					List<string> core1 = new List<string>();
					List<string> core2 = new List<string>();
					core1.Clear();
					core2.Clear();
					
					
					CompoundStructure comStruct= ct.GetCompoundStructure();
					int firstCore=comStruct.GetFirstCoreLayerIndex();//index of first core - from exterior
					int lastCore=comStruct.GetLastCoreLayerIndex();//index of last core - from exterior
					int sandwichID=0;
					
					core1=curRow.ToList();/// add range and additions do not work because curRow value changes later, so use ToList
					core1.Add((firstCore+1).ToString());
					core1.Add("Core Upper");
					outputRowsLayers.Add(firstCore+1,core1);

					core2=curRow.ToList();
					core2.Add((lastCore+3).ToString());
					core2.Add("Core Lower");

					outputRowsLayers.Add(lastCore+3,core2);
					
					foreach (CompoundStructureLayer structLayer in comStruct.GetLayers())
					{
						List <string> tmpRow= new List<string>();// to hold temp for one layer
						tmpRow.Clear();
						/// figure out sandwich layer number
						
						tmpRow.AddRange(curRow);
						
						
						if (structLayer.LayerId<firstCore)
						{
							sandwichID=structLayer.LayerId+1;
							
						}
						
						else
						{
							if (structLayer.LayerId>=firstCore)
							{
								if (!(structLayer.LayerId>lastCore))//between cores
								{
									sandwichID=structLayer.LayerId+2;
									
									
								}
								else{//outside last core
									sandwichID=structLayer.LayerId+3;

								}
							}
						}
						tmpRow.Add(sandwichID.ToString());
						
						
						// Material of its Category, need to indicate that it came from category!!!!!
						Autodesk.Revit.DB.Material layerMaterial =doc.GetElement(structLayer.MaterialId) as Material;  //this is fine if material is assigned explicitly
						
						if (null == layerMaterial)//not assigned- by category, get material from wall category
						{
							// CompoundStructureLayer's default Material is its SubCategory
							layerMaterial = CeilingMaterial;
						}
						
						if (null == layerMaterial)//still Null if ceiling material is not assigned!!!!
						{
							tmpRow.Add("by category-not defined");
						}
						else{ tmpRow.Add(layerMaterial.Name);
						}
						
						tmpRow.Add(structLayer.Function.ToString());
						tmpRow.Add((structLayer.Width*12).ToString());
						tmpRow.Add((structLayer.LayerCapFlag).ToString());
						
						//curRow.AddRange(tmpRow);
						
						outputRowsLayers.Add(sandwichID,tmpRow);
						
						
					}//end of layers
					
					outputRows.AddRange(outputRowsLayers.Values.ToList());
				}else//no layers
				{
					outputRows.Add(curRow);
					
				}// end of compound ceiling
				
			}//end of ceiling collection
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet20);
			#endregion
			#region Floors

			/// floors !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet21 = (Worksheet)workbook.ActiveSheet;
			worksheet21.Name="floors";
			
			FilteredElementCollector FloorTypes= new FilteredElementCollector(doc).OfClass(typeof(FloorType));
			
			//SortedList<int,string> listLayers = new SortedList<int,string>();
			
			string strFloorHeader= "floor family! floor type!LayerID!Layermaterial!Layer Function!Layer thickness in Inches! layer wrap flag";
			List<string> Fheader = strFloorHeader.Split('!').ToList<string>();
			outputRows.Add(Fheader);
			
			foreach (FloorType ft in FloorTypes) {
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				curRow.Add(ft.FamilyName);
				curRow.Add(ft.Name);
				//curRow.Add(ft.IsFoundationSlab);
				//curRow.Add((ct.Width*12).ToString()); // only exists in compouund structure exists
				
				//outputRows.Add(curRow); not needed, will be affed with layers
				//if (ft.FamilyName=="Compound Ceiling")
				//{
				
				Categories allCategories = doc.Settings.Categories;
				Category FloorCategory = allCategories.get_Item(BuiltInCategory.OST_Floors);
				Autodesk.Revit.DB.Material FloorMaterial = FloorCategory.Material; ////null???????????????  this happens when wall category doe not have a material assigned
				
				SortedList<int,List<string>> outputRowsLayers= new SortedList<int,List<string>>(); //to hold multple rows of data for Layers and be able to sort by integer later
				outputRowsLayers.Clear();
				List<string> core1 = new List<string>();
				List<string> core2 = new List<string>();
				core1.Clear();
				core2.Clear();
				
				
				CompoundStructure comStruct= ft.GetCompoundStructure();
				int firstCore=comStruct.GetFirstCoreLayerIndex();//index of first core - from exterior
				int lastCore=comStruct.GetLastCoreLayerIndex();//index of last core - from exterior
				int sandwichID=0;
				
				core1=curRow.ToList();/// add range and additions do not work because curRow value changes later, so use ToList
				core1.Add((firstCore+1).ToString());
				core1.Add("Core Upper");
				outputRowsLayers.Add(firstCore+1,core1);

				core2=curRow.ToList();
				core2.Add((lastCore+3).ToString());
				core2.Add("Core Lower");

				outputRowsLayers.Add(lastCore+3,core2);
				
				foreach (CompoundStructureLayer structLayer in comStruct.GetLayers())
				{
					List <string> tmpRow= new List<string>();// to hold temp for one layer
					tmpRow.Clear();
					/// figure out sandwich layer number
					
					tmpRow.AddRange(curRow);
					
					
					if (structLayer.LayerId<firstCore)
					{
						sandwichID=structLayer.LayerId+1;
						
					}
					
					else
					{
						if (structLayer.LayerId>=firstCore)
						{
							if (!(structLayer.LayerId>lastCore))//between cores
							{
								sandwichID=structLayer.LayerId+2;
								
								
							}
							else{//outside last core
								sandwichID=structLayer.LayerId+3;

							}
						}
					}
					tmpRow.Add(sandwichID.ToString());
					
					
					// Material of its Category, need to indicate that it came from category!!!!!
					Autodesk.Revit.DB.Material layerMaterial =doc.GetElement(structLayer.MaterialId) as Material;  //this is fine if material is assigned explicitly
					
					if (null == layerMaterial)//not assigned- by category, get material from wall category
					{
						// CompoundStructureLayer's default Material is its SubCategory
						layerMaterial = FloorMaterial;
					}
					
					if (null == layerMaterial)//still Null if ceiling material is not assigned!!!!
					{
						tmpRow.Add("by category-not defined");
					}
					else{ tmpRow.Add(layerMaterial.Name);
					}
					
					tmpRow.Add(structLayer.Function.ToString());
					tmpRow.Add((structLayer.Width*12).ToString());
					tmpRow.Add((structLayer.LayerCapFlag).ToString());
					
					//curRow.AddRange(tmpRow);
					
					outputRowsLayers.Add(sandwichID,tmpRow);
					
					
				}//end of layers
				
				outputRows.AddRange(outputRowsLayers.Values.ToList());
				//	}// end of compound floor
				
			}//end of floor collection
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet21);
			#endregion
			#region Roofs


			/// Roofs!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet22 = (Worksheet)workbook.ActiveSheet;
			worksheet22.Name="Roofs";
			
			FilteredElementCollector RoofTypes= new FilteredElementCollector(doc).OfClass(typeof(RoofType));
			
			//SortedList<int,string> listLayers = new SortedList<int,string>();
			
			string strRoofHeader= "roof family! roof type!LayerID!Layermaterial!Layer Function!Layer thickness in Inches! layer wrap flag";
			List<string> Rheader = strRoofHeader.Split('!').ToList<string>();
			outputRows.Add(Rheader);
			
			foreach (RoofType rt in RoofTypes) {
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				curRow.Add(rt.FamilyName);
				curRow.Add(rt.Name);
				//curRow.Add(ft.IsFoundationSlab);
				//curRow.Add((ct.Width*12).ToString()); // only exists in compouund structure exists
				
				
				if (rt.FamilyName=="Basic Roof")
				{
					
					Categories allCategories = doc.Settings.Categories;
					Category RoofCategory = allCategories.get_Item(BuiltInCategory.OST_Roofs);
					Autodesk.Revit.DB.Material RoofMaterial = RoofCategory.Material; ////null???????????????  this happens when wall category doe not have a material assigned
					
					SortedList<int,List<string>> outputRowsLayers= new SortedList<int,List<string>>(); //to hold multple rows of data for Layers and be able to sort by integer later
					outputRowsLayers.Clear();
					List<string> core1 = new List<string>();
					List<string> core2 = new List<string>();
					core1.Clear();
					core2.Clear();
					
					
					CompoundStructure comStruct= rt.GetCompoundStructure();
					int firstCore=comStruct.GetFirstCoreLayerIndex();//index of first core - from exterior
					int lastCore=comStruct.GetLastCoreLayerIndex();//index of last core - from exterior
					int sandwichID=0;
					
					core1=curRow.ToList();/// add range and additions do not work because curRow value changes later, so use ToList
					core1.Add((firstCore+1).ToString());
					core1.Add("Core Upper");
					outputRowsLayers.Add(firstCore+1,core1);

					core2=curRow.ToList();
					core2.Add((lastCore+3).ToString());
					core2.Add("Core Lower");

					outputRowsLayers.Add(lastCore+3,core2);
					
					
					
					foreach (CompoundStructureLayer structLayer in comStruct.GetLayers())
					{
						List <string> tmpRow= new List<string>();// to hold temp for one layer
						tmpRow.Clear();
						/// figure out sandwich layer number
						
						tmpRow.AddRange(curRow);
						
						if (structLayer.LayerId<firstCore)
						{
							sandwichID=structLayer.LayerId+1;
							
						}
						
						else
						{
							if (structLayer.LayerId>=firstCore)
							{
								if (!(structLayer.LayerId>lastCore))//between cores
								{
									sandwichID=structLayer.LayerId+2;
									
									
								}
								else{//outside last core
									sandwichID=structLayer.LayerId+3;

								}
							}
						}
						tmpRow.Add(sandwichID.ToString());
						
						
						// Material of its Category, need to indicate that it came from category!!!!!
						Autodesk.Revit.DB.Material layerMaterial =doc.GetElement(structLayer.MaterialId) as Material;  //this is fine if material is assigned explicitly
						
						if (null == layerMaterial)//not assigned- by category, get material from wall category
						{
							// CompoundStructureLayer's default Material is its SubCategory
							layerMaterial = RoofMaterial;
						}
						
						if (null == layerMaterial)//still Null if ceiling material is not assigned!!!!
						{
							tmpRow.Add("by category-not defined");
						}
						else{ tmpRow.Add(layerMaterial.Name);
						}
						
						tmpRow.Add(structLayer.Function.ToString());
						tmpRow.Add((structLayer.Width*12).ToString());
						tmpRow.Add((structLayer.LayerCapFlag).ToString());
						
						//curRow.AddRange(tmpRow);
						
						outputRowsLayers.Add(sandwichID,tmpRow);
						
						
					}//end of layers
					
					outputRows.AddRange(outputRowsLayers.Values.ToList());
				}else//no layers
				{
					outputRows.Add(curRow);
					
				}// end of compound
			}//end of  collection
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet22);
			#endregion
			#region ViewFamilyTypes

			/// view family types!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			/// 
			///
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet23 = (Worksheet)workbook.ActiveSheet;
			worksheet23.Name="View Types";
			FilteredElementCollector colViewTypes = new FilteredElementCollector(doc);
			colViewTypes.OfClass(typeof(ViewFamilyType));//.ToElements();// get all views
			List <string> parNames= new List<string>();
			parNames.Add("View template applied to new views");
			parNames.Add("New Views are deoendent on template");
			parNames.Add("Section Tag");
			parNames.Add("Reference Label");
			parNames.Add("Callout Tag");
			parNames.Add("View Direction");
			parNames.Add("Elevation Tag");
			parNames.Add("Elevation Tag");
			
			outRow.Add("ViewType");
			outRow.Add("ViewFamilyType");
			outRow.AddRange(parNames.ToList());
			outputRows.Add(outRow);
			
			
			foreach (ViewFamilyType viewtype in colViewTypes)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(viewtype.Name);
				curRow.Add(viewtype.FamilyName);
				
				foreach (String curpar in parNames)
				{
					if (viewtype.LookupParameter(curpar)==null)
					{
						curRow.Add("NULL");
					}
					else{
						
						curRow.Add(GetParameterValue(viewtype.LookupParameter(curpar),doc));
					}
				}
				

				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet23);/// </dimstyles>
			#endregion
			#region StairTypes

			/// stair types !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet24 = (Worksheet)workbook.ActiveSheet;
			worksheet24.Name="stairs";
			FilteredElementCollector colStairs = new FilteredElementCollector(doc);
			colStairs.OfClass(typeof(StairsType)).ToElements();// get all stairs
			foreach (StairsType StType in colStairs)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(StType.Name);
				
				outRow=curRow;
				outputRows.Add(outRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet24);
			#endregion
			#region Railings

			
//				/// railings  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet25 = (Worksheet)workbook.ActiveSheet;
		worksheet25.Name="railings";
			FilteredElementCollector colRailing = new FilteredElementCollector(doc);
			colRailing.OfClass(typeof(RailingType)).ToElements();// get all stairs
			foreach (RailingType RlType in colRailing)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(RlType.Name);
				
				outRow=curRow;
				outputRows.Add(outRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet25);
			#endregion
			#region FilledRegions

			/// Filled Regions  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			/// 
			//need to figure out hot to report backbgound patterns!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet26 = (Worksheet)workbook.ActiveSheet;
			worksheet26.Name="filled regions";
			FilteredElementCollector colFillR = new FilteredElementCollector(doc);
			colFillR.OfClass(typeof(FilledRegionType)).ToElements();// get all filled regions
			foreach (FilledRegionType FRType in colFillR)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(FRType.Name);
				
				
				try
				{
					curRow.Add((doc.GetElement(FRType.ForegroundPatternId)).Name);  //do not need anything else, it is reported in fill patterns. but is the pattern name is empty, need to catch
				}
				catch (Exception e)
				{
					curRow.Add(" Fill pattern is not defined!!!");
				}
				
				
				outRow=curRow;
				outputRows.Add(outRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet26);
			#endregion
			#region Groups

//				/// Groups  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet27 = (Worksheet)workbook.ActiveSheet;
			worksheet27.Name="Groups";
			FilteredElementCollector colGroups = new FilteredElementCollector(doc);
			colGroups.OfClass(typeof(GroupType)).ToElements();// 
			if (colGroups.Count()==0) {
				outRow.Add("NO Groups");
				outputRows.Add(outRow);
			}
			foreach (GroupType GrType in colGroups)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(GrType.Category.Name);
				curRow.Add(GrType.Name);
				
				
				outRow=curRow;
				outputRows.Add(outRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet27);
			#endregion
			#region Families

			/// families - in-place, some system and loaded !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet28 = (Worksheet)workbook.ActiveSheet;
			worksheet28.Name="Families";
			FilteredElementCollector colFamily = new FilteredElementCollector(doc);
			colFamily.OfClass(typeof(Family)).ToElements();// all families
			
			
			if (colFamily.Count()==0) {
				outRow.Add("NO Families");
				outputRows.Add(outRow);
			}
			foreach (Family fam in colFamily)
			{
				
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				curRow.Add(fam.FamilyCategory.Name);
				curRow.Add(fam.Name);
				
				
//			    if ((!fam.IsInPlace)&&(fam.IsUserCreated)&&(fam.IsEditable)&&(!fam.IsCurtainPanelFamily)) {
//
//			}
				try {
					Document famDoc = doc.EditFamily(fam);
					if (famDoc.PathName!=null) {
						curRow.Add(famDoc.PathName);
					}
					
					famDoc.Close(false);
				} catch (Exception) {
					curRow.Add("not editable family");
					outRow=curRow;
					outputRows.Add(outRow);
					
				}
				
				
				
				outRow=curRow;
				outputRows.Add(outRow);
				
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet28);
			#endregion
			#region Units

//
			/// Units!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			/// 
			///
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet29 = (Worksheet)workbook.ActiveSheet;
			worksheet29.Name="Units";
			Units units = doc.GetUnits();
			IList<UnitType> unitTypes = UnitUtils.GetValidUnitTypes();
			string Uheaders="Measure, Unit display, Unit symbol,Accuracy,Rounding Method, Use default,Use digit grouping,Use plus prefix,Suppress spaces,Suppress leading zeros,Suppress trailing zeros";
			outRow.AddRange(Uheaders.Split(',').ToList());
			outputRows.Add(outRow);
			//
			foreach (UnitType ut in unitTypes)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(ut.ToString());

				FormatOptions fmtOpts = units.GetFormatOptions(ut);
				curRow.Add(fmtOpts.DisplayUnits.ToString());
				curRow.Add(fmtOpts.UnitSymbol.ToString());
				curRow.Add(fmtOpts.Accuracy.ToString());
				curRow.Add(fmtOpts.RoundingMethod.ToString());
				curRow.Add(fmtOpts.UseDefault.ToString());
				curRow.Add(fmtOpts.UseDigitGrouping.ToString());
				curRow.Add(fmtOpts.UsePlusPrefix.ToString());
				curRow.Add(fmtOpts.SuppressSpaces.ToString());
				curRow.Add(fmtOpts.SuppressLeadingZeros.ToString());
				curRow.Add(fmtOpts.SuppressTrailingZeros.ToString());
				//curRow.Add(fmtOpts.IsValidObject.ToString());
				
				outputRows.Add(curRow);
				
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet29);/// <Units>
			#endregion
			#region SheetsWithViews

			/// Sheets with views!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			///

			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet30 = (Worksheet)workbook.ActiveSheet;
			worksheet30.Name="Sheets";
			//string SheetHheaders="SheetNumber,viewtype, View name, view element ID";
			
			//get all sheets
			FilteredElementCollector collectorSheets = new FilteredElementCollector(doc);
			collectorSheets.OfClass(typeof(Autodesk.Revit.DB.ViewSheet));
			
			
			foreach (ViewSheet sheet in collectorSheets)//this gets all except schedules, a line for each view
				
			{
				
				

				ICollection<ElementId> views = sheet.GetAllPlacedViews();/// get all views on the sheet
				foreach (ElementId viewID in views)
					
				{
					List <string> curRow= new List<string>();// to hold temp for one row
					View curView = doc.GetElement(viewID) as View; ////get the view object
					ViewType curViewType=curView.ViewType;
					Element elemType = doc.GetElement(curView.GetTypeId());//get the full view type as element
					
					curRow.Add(sheet.SheetNumber.ToString());
					curRow.Add(elemType.Name.ToString());
					curRow.Add(curView.Name.ToString());
					curRow.Add(viewID.ToString());
					outRow=curRow;
					outputRows.Add(outRow);
				}
				
				
			}
			
			
			//get  schedules on sheets!!!!!!!
			
			FilteredElementCollector collectorscheduleInstances = new FilteredElementCollector(doc);
			collectorscheduleInstances.OfClass(typeof(Autodesk.Revit.DB.ScheduleSheetInstance));//got all schedule instances
			
			int schedulecount=collectorscheduleInstances.GetElementCount();
			if (schedulecount==0)
			{
				outRow.Add(" ");
				outputRows.Add(outRow);
			}
			
			
			foreach (ScheduleSheetInstance placedschedule in collectorscheduleInstances)
			{
				
				//get the ID of owner view - that will be sheet ID
				ElementId hostSheetID=placedschedule.OwnerViewId; ///HA!!! got slippery object!!!!!!!!!!!!!!!!!
				ViewSheet curSheet= doc.GetElement(hostSheetID) as ViewSheet;
				
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(curSheet.SheetNumber.ToString());
				
				curRow.Add("Schedule");//type name is rolled into shcedule name there are schedules only in this collection
				curRow.Add(placedschedule.Name.ToString());
				curRow.Add(placedschedule.Id.ToString());
				
				outRow=curRow;
				outputRows.Add(outRow);
				
			}
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet30);/// sheets


			/// end of Sheets with views  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			#endregion
			#region AllRegularViews

//				//all regular views !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			outputRows.Clear();
			outRow.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet31 = (Worksheet)workbook.ActiveSheet;
			worksheet31.Name="Views-general";
			//	FilteredElementCollector collectorViews = new FilteredElementCollector(doc); /////alreadt have then
			//	collectorViews.OfClass(typeof(View)).ToElements();// get all views
			foreach (View view in collectorViews)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				
				if (!view.IsTemplate)
				{
					
					//if (view.ViewType== ViewType.AreaPlan) {
					
					curRow.Add(view.ViewType.ToString());
					curRow.Add(view.Name);
					curRow.Add(view.Id.ToString());
					
					
					
					try {
						curRow.Add(view.Scale.ToString());
					} catch (Exception e)

					{
						curRow.Add("undefined");
					}

					
					try {
						curRow.Add(view.DetailLevel.ToString());
					} catch (Exception )
						
						
					{
						curRow.Add("undefined");
					}

					
					
					if (view.ViewTemplateId.IntegerValue>0)
					{
						View curTemplate= doc.GetElement(view.ViewTemplateId) as View;
						curRow.Add(curTemplate.Name);
					}
					
					outRow=curRow;
					outputRows.Add(curRow);
					
					//}
				}
				
			}
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet31);

			#endregion
			#region labelTypes
			
			/// <label styles/!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet32 = (Worksheet)workbook.ActiveSheet;
			worksheet32.Name="label Types";
			
			var  collabelstyles = new FilteredElementCollector(doc);
			collabelstyles.OfClass(typeof(TextElementType)).ToList();// get all label styles
			
			
			foreach (TextElementType  labelNtype in collabelstyles)
			{
				
				/// cast as text type, and if does not, then it is a label
				
				
				//var TextNoteType=labelNtype as TextNoteType; //when it is not a TextNoteType ( therefore it is a label) , the cast will be null
				
				if (!(labelNtype is TextNoteType)) {
					
					List <string> curRow= new List<string>();// to hold temp for one row
					curRow.Add(labelNtype.Name);
					foreach (Autodesk.Revit.DB.Parameter para in labelNtype.GetOrderedParameters())
					{
						//sb.AppendLine(GetParameterInformation(para, doc));
						string defName = para.Definition.Name;
						// Use different method to get parameter data according to the storage type
						switch (para.StorageType)
						{
							case StorageType.Double:
								//covert the number into units
								
								curRow.Add(defName+ ":" +para.AsValueString());
								
								break;
							case StorageType.ElementId:
								//find out the name of the element
								ElementId id = para.AsElementId();
								if (id.IntegerValue >= 0)
								{
									curRow.Add(defName + ":" +doc.GetElement(id).Name);
									
								}
								else
								{
									curRow.Add(defName + ":" +id.ToString());
								}
								break;
							case StorageType.Integer:
								if (ParameterType.YesNo == para.Definition.ParameterType)
								{
									if (para.AsInteger() == 0)
									{
										curRow.Add(defName+ ":" +"False");
									}
									else
									{
										curRow.Add(defName+ ":" +"True");
									}
								}
								else
								{
									curRow.Add(defName+ ":" +para.AsInteger().ToString());
								}
								break;
							case StorageType.String:
								curRow.Add(defName+ ":" +para.AsString());
								break;
							default:
								curRow.Add("Unexposed parameter");
								break;
						}
						
					}
					outputRows.Add(curRow);
				}
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet32);/// 
			#endregion
			#region ProjectInfo
			
			/// <ProjectInfo/!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			
			outRow.Clear();
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet33 = (Worksheet)workbook.ActiveSheet;
			worksheet33.Name="ProjectInfo";
			ProjectInfo projectInfo = doc.ProjectInformation;
			
			foreach (Autodesk.Revit.DB.Parameter para in projectInfo.GetOrderedParameters())
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Clear();
				string defName = para.Definition.Name;
				// Use different method to get parameter data according to the storage type
				curRow.Add(defName);
				switch (para.StorageType)
				{
					case StorageType.Double:
						//covert the number into units
						
						curRow.Add(para.AsValueString());
						break;
					case StorageType.ElementId:
						//find out the name of the element
						ElementId id = para.AsElementId();
						if (id.IntegerValue >= 0)
						{
							
							curRow.Add(doc.GetElement(id).Name);
							
						}
						else
						{
							
							curRow.Add(id.ToString());
						}
						break;
					case StorageType.Integer:
						if (ParameterType.YesNo == para.Definition.ParameterType)
						{
							if (para.AsInteger() == 0)
							{
								
								curRow.Add("False");
							}
							else
							{
								
								curRow.Add("True");
							}
						}
						else
						{
							
							curRow.Add(para.AsInteger().ToString());
						}
						break;
					case StorageType.String:
						curRow.Add(para.AsString());
						break;
					default:
						curRow.Add("Unexposed parameter");
						break;
				}
				outRow=curRow;
				outRow.Add(para.IsReadOnly.ToString());
				if (para.IsShared) {
					outRow.Add(para.GUID.ToString());
				}
				
				
				outputRows.Add(outRow);
			}
			
			
			
			
			
			
			
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet33);/// 
			#endregion
			#region ModelTextstyles
			
			/// ModelTextstyles/!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet34 = (Worksheet)workbook.ActiveSheet;
			worksheet34.Name="ModTextStyle";
			
			var  modeltextstyles = new FilteredElementCollector(doc);
			modeltextstyles.OfClass(typeof(ModelTextType)).ToList();// get all modeltext styles
			
			
			foreach (ModelTextType  mtstyle in modeltextstyles)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(mtstyle.Name);
				curRow.Add(mtstyle.FamilyName);
				
				foreach (Autodesk.Revit.DB.Parameter para in mtstyle.GetOrderedParameters())
				{
					//sb.AppendLine(GetParameterInformation(para, doc));
					string defName = para.Definition.Name;
					// Use different method to get parameter data according to the storage type
					switch (para.StorageType)
					{
						case StorageType.Double:
							//covert the number into units
							
							curRow.Add(defName+ ":" +para.AsValueString());
							
							break;
						case StorageType.ElementId:
							//find out the name of the element
							ElementId id = para.AsElementId();
							if (id.IntegerValue >= 0)
							{
								curRow.Add(defName + ":" +doc.GetElement(id).Name);
								
							}
							else
							{
								curRow.Add(defName + ":" +id.ToString());
							}
							break;
						case StorageType.Integer:
							if (ParameterType.YesNo == para.Definition.ParameterType)
							{
								if (para.AsInteger() == 0)
								{
									curRow.Add(defName+ ":" +"False");
								}
								else
								{
									curRow.Add(defName+ ":" +"True");
								}
							}
							else
							{
								curRow.Add(defName+ ":" +para.AsInteger().ToString());
							}
							break;
						case StorageType.String:
							curRow.Add(defName+ ":" +para.AsString());
							break;
							//		curRow.Add("Unexposed parameter");
							//	break;
					}
					
				}
				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet34);/// 
			#endregion
			#region RevisionSettings
			/// RevisionSettings/!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet35 = (Worksheet)workbook.ActiveSheet;
			worksheet35.Name="RevisionSettings";
			
			var  revsettings = new FilteredElementCollector(doc);
			revsettings.OfClass(typeof(RevisionSettings)).ToList();// get revisionsettings
			
			
			foreach (RevisionSettings  rsetting  in revsettings)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				RevisionSettings rs=rsetting as RevisionSettings;
				curRow.Add(rs.RevisionCloudSpacing.ToString());
				
				//curRow.Add(rs.RevisionAlphabet.ToString()); not5 implemented ? exists in API but throws an error
				
				curRow.Add(rs.RevisionNumbering.ToString());
				
				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet35);/// 
			#endregion
			#region ProjectLocations
			/// ProjectLocation/!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet36 = (Worksheet)workbook.ActiveSheet;
			worksheet36.Name="ProjectLocation";
			outRow.Clear();
			
			
			
			ProjectLocation projectLocation = doc.ActiveProjectLocation;// this is for survey point, even when it is not shared and no multiple positions
			// Show the information of current project location
			XYZ origin = new XYZ(0, 0, 0);
			// Angles are in radians when coming from Revit API, so we
			// convert to degrees for display
			const double angleRatio = Math.PI / 180;   // angle conversion factor
			
			
			
			{
				List <string> curRow= new List<string>();// to hold temp for one row temp
				curRow.Add("projectLocation name");
				 curRow.Add(projectLocation.Name);
				outputRows.Add(curRow);
			}
			
			
			ProjectPosition position = projectLocation.GetProjectPosition(origin);
			if (null == position)
			{
				throw new Exception("No project position in origin point.");
			}
			
			
			{
				List <string> curRow= new List<string>();// to hold temp for one row temp
				curRow.Add("Origin point Angle");
				curRow.Add((position.Angle/ angleRatio).ToString());
				outputRows.Add(curRow);
			}
			
						
			{
				List <string> curRow= new List<string>();// to hold temp for one row temp
				curRow.Add("Origin point East to West offset" + position.EastWest.ToString());
				curRow.Add(position.EastWest.ToString());
				outputRows.Add(curRow);
			}
			
			{
				List <string> curRow= new List<string>();// to hold temp for one row temp
				curRow.Add("Origin point Elevation" + position.Elevation.ToString());
				curRow.Add(position.Elevation.ToString());
				outputRows.Add(curRow);
			}
			
			{
				List <string> curRow= new List<string>();// to hold temp for one row temp
				curRow.Add("Origin point North to South offset: " + position.NorthSouth.ToString());
				curRow.Add(position.NorthSouth.ToString());
				outputRows.Add(curRow);;
			}
			
			
			SiteLocation site = projectLocation.GetSiteLocation();
			
					
			{
				List <string> curRow= new List<string>();// to hold temp for one row temp
				curRow.Add("Site location Latitude ");
				curRow.Add((site.Latitude / angleRatio).ToString() + "º");
				outputRows.Add(curRow);
			}
			
			{
				List <string> curRow= new List<string>();// to hold temp for one row temp
				curRow.Add("Site location Longitude: ");
				curRow.Add((site.Longitude / angleRatio).ToString() + "º");
				outputRows.Add(curRow);
			}
			
			{
				List <string> curRow= new List<string>();// to hold temp for one row temp
				curRow.Add("Site location TimeZone: ");
				curRow.Add(site.TimeZone.ToString());
				outputRows.Add(curRow);
			}
			
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet36);/// 
			#endregion
			#region BasePoints
			/// BasePoints/!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet37 = (Worksheet)workbook.ActiveSheet;
			worksheet37.Name="Basepoints";
			outRow.Clear();
			
			var  basepoints = new FilteredElementCollector(doc);
			basepoints.OfClass(typeof(BasePoint)).ToList();// get all basepoints. there is minimum of 2 - project base point and survey point
			
			
			// Angles are in radians when coming from Revit API, so we
			// convert to degrees for display
						
			foreach (BasePoint bpt in basepoints) {
				
				List <string> curRow= new List<string>();// to hold temp for one row
				
				String pttype="";
				if (bpt.IsShared) {
			 pttype="SurveyPoint";	
				} else {
			pttype="ProjectBasePoint";
				}
				outRow=curRow;
				outputRows.Add(outRow);
				
				
				foreach (Autodesk.Revit.DB.Parameter para in bpt.GetOrderedParameters())
				{				
					
					List <string> currRow= new List<string>();// to hold temp for one row
					currRow.Clear();
					string defName = para.Definition.Name;
					// Use different method to get parameter data according to the storage type
					currRow.Add(pttype+ " "+ defName);
					switch (para.StorageType)
					{
						case StorageType.Double:
							//covert the number into units
							
							currRow.Add(para.AsValueString());
							break;
						case StorageType.ElementId:
							//find out the name of the element
							ElementId id = para.AsElementId();
							if (id.IntegerValue >= 0)
							{
								
								currRow.Add(doc.GetElement(id).Name);
								
							}
							else
							{
								
								currRow.Add(id.ToString());
							}
							break;
						case StorageType.Integer:
							if (ParameterType.YesNo == para.Definition.ParameterType)
							{
								if (para.AsInteger() == 0)
								{
									
									currRow.Add("False");
								}
								else
								{
									
									currRow.Add("True");
								}
							}
							else
							{
								
								currRow.Add(para.AsInteger().ToString());
							}
							break;
						case StorageType.String:
							currRow.Add(para.AsString());
							break;
						default:
							currRow.Add("Unexposed parameter");
							break;
					}
					outRow=currRow;
					outRow.Add(para.IsReadOnly.ToString());
					if (para.IsShared) {
						outRow.Add(para.GUID.ToString());
					}
					outputRows.Add(outRow);
				}
				
			}
			
			
			
			
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet37);/// 
			#endregion
			#region slabEdges
			
			/// slabEdges/!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			
			outputRows.Clear();
			excelApp.Worksheets.Add();
			Worksheet worksheet38 = (Worksheet)workbook.ActiveSheet;
			worksheet38.Name="slabEdges";
			
			var  slabEdges = new FilteredElementCollector(doc);
			slabEdges.OfClass(typeof(SlabEdgeType)).ToList();// get all slabedges styles
			
			
			foreach (SlabEdgeType  slt in slabEdges)
			{
				List <string> curRow= new List<string>();// to hold temp for one row
				curRow.Add(slt.Name);
				outputRows.Add(curRow);
			}
			ToExcel( outputRows, oOpt, ref excelApp, ref workbook, worksheet38);/// 
	#endregion		



			


			// Save the file
			workbook.SaveAs(filename,XlFileFormat.xlOpenXMLWorkbook,
			                Missing.Value, Missing.Value, Missing.Value, Missing.Value,
			                XlSaveAsAccessMode.xlExclusive, Missing.Value, Missing.Value, Missing.Value,
			                Missing.Value, Missing.Value);
			
			
			// Clean up the excel resources that were created
			workbook.Close();
			excelApp.Quit();
			
		}

		
		
		String GetParameterInformation(Autodesk.Revit.DB.Parameter para, Document document)//gets parameter definition and values
		{
			string defName = para.Definition.Name + @"\t";
			// Use different method to get parameter data according to the storage type
			switch (para.StorageType)
			{
				case StorageType.Double:
					//covert the number into Metric
					defName += " : " + para.AsValueString();
					break;
				case StorageType.ElementId:
					//find out the name of the element
					Autodesk.Revit.DB.ElementId id = para.AsElementId();
					if (id.IntegerValue >= 0)
					{
						defName += " : " + document.GetElement(id).Name;
					}
					else
					{
						defName += " : " + id.IntegerValue.ToString();
					}
					break;
				case StorageType.Integer:
					if (ParameterType.YesNo == para.Definition.ParameterType)
					{
						if (para.AsInteger() == 0)
						{
							defName += " : " + "False";
						}
						else
						{
							defName += " : " + "True";
						}
					}
					else
					{
						defName += " : " + para.AsInteger().ToString();
					}
					break;
				case StorageType.String:
					defName += " : " + para.AsString();
					break;
				default:
					defName = "Unexposed parameter.";
					break;
			}

			return defName;
		}
		String GetParameterValue(Autodesk.Revit.DB.Parameter para, Document document) //gets parameters valies
		{
			string paraText = para.Definition.Name + @"\t";
			// Use different method to get parameter data according to the storage type
			switch (para.StorageType)
			{
				case StorageType.Double:
					//convert the number into Metric
					paraText=para.AsValueString();
					break;
				case StorageType.ElementId:
					//find out the name of the element
					Autodesk.Revit.DB.ElementId id = para.AsElementId();
					if (id.IntegerValue >= 0)
					{
						paraText= document.GetElement(id).Name;
					}
					else
					{
						paraText=id.IntegerValue.ToString();
					}
					break;
				case StorageType.Integer:
					if (ParameterType.YesNo == para.Definition.ParameterType)
					{
						if (para.AsInteger() == 0)
						{
							paraText="False";
						}
						else
						{
							paraText="True";
						}
					}
					else
					{
						paraText= para.AsInteger().ToString();
					}
					break;
				case StorageType.String:
					paraText= para.AsString();
					break;
				default:
					paraText = "Unexposed parameter.";
					break;
			}

			return paraText;
		}
		void ToExcel(List<List<string>> outputRows,object oOpt, ref Application excelApp,ref Workbook workbook, Worksheet worksheet)
		{
			int numberOfRows = outputRows.Count;
			int numberOfColumns = int.MinValue;
			numberOfRows=outputRows.Count;
			
			foreach (List<string> Row in outputRows) {
				if (numberOfColumns < Row.Count) {
					numberOfColumns = Row.Count;
				}
			}
			Microsoft.Office.Interop.Excel.Range oRng = worksheet.get_Range("A1", oOpt).get_Resize(numberOfRows, numberOfColumns);
			object[,] outputArray = new object[numberOfRows, numberOfColumns];
			for (int row = 0; row < numberOfRows; row++) {
				for (int col = 0; col < outputRows[row].Count; col++) {
					outputArray[row, col] = outputRows[row][col];
				}
			}
			oRng.set_Value(oOpt, outputArray);
			///this is to fit all
			foreach (Microsoft.Office.Interop.Excel.Worksheet wrkst in workbook.Worksheets)
			{
				Microsoft.Office.Interop.Excel.Range usedrange = wrkst.UsedRange;
				usedrange.Columns.AutoFit();
			}
			
		}
		
		//this is to save to xlsx
		
		public void FamilyBatchThumbnail()
		{
			/// <summary>
			/// Use for 2D families - turns odd refmplanes and reflines
			/// </summary>
			
			string strInput;
			string strOutputRoot;
			bool Go;
			bool Subfolders;
			string[] filePaths;
			//using
			using (frmFamiliesToProcess curForm = new frmFamiliesToProcess()){    /// accessing var from the form and passing them to the refplanes
//			//show form
				curForm.ShowDialog();
				
				strInput=curForm.strInput;
				if (strInput.Length<3) {
					TaskDialog.Show("Invalid input path",strInput);
					curForm.ShowDialog();
				}
				strOutputRoot=curForm.strOutput;
				if (strOutputRoot.Length<3) {
					TaskDialog.Show("Invalid output path",strOutputRoot);
					curForm.ShowDialog();
				}
				
				Go=curForm.Go;
				if (!Go) {
					TaskDialog.Show("Diagnostic"," Cancelled by user");
				}
				Subfolders=curForm.Subfolders;
			}
			
			////get a list of files
			/// 
			
			
			if (Subfolders)
			{
				filePaths = Directory.GetFiles(@strInput,"*.rfa",SearchOption.AllDirectories);
			}
			else
			{
				filePaths = Directory.GetFiles(@strInput,"*.rfa",SearchOption.TopDirectoryOnly);
			}
			
			
//				if (filePaths.Count()>0)
//				//delete backup files from the array- filter the array
			List<string> filteredPaths = new List<string>();
			foreach (string path in filePaths) {
				if (!path.Contains(".00")) {
					filteredPaths.Add(path);
				}
			}
			if (filteredPaths.Count.Equals(0)) {
				TaskDialog.Show("diagnostic", "no valid family files found");
			}
			
			else{
				//open every family, process, save as and close
				if (Go)
				{
					foreach (string familyfile in filteredPaths) {
						// curFam;
						
						//int start=familyfile.IndexOf(strInput)+strInput.Length+1;
						//int end=(familyfile.Length-1);
						//string  fromRoot= familyfile.Substring((familyfile.IndexOf(strInput)+strInput.Length+1),(familyfile.Length-1));
						string[] filename=familyfile.Split('\\');
						string filenameShort= filename[(filename.Count()-1)];
						string filenameOut=familyfile.Replace(strInput,strOutputRoot);
						//string folderOut=
						//string filenameOut=strOutputRoot+"\\"+filenameShort;
						
						// Set to folder path we must ensure exists.
						string pathOut = filenameOut.Replace(filenameShort,"");
						try
						{
							// If the directory doesn't exist, create it.
							if (!Directory.Exists(pathOut))
							{
								Directory.CreateDirectory(pathOut);
							}
						}
						catch (Exception)
						{
							// Fail silently
						}
						
						
						UIDocument	curFam= OpenAndActivateDocument(familyfile)	;
						
						refPlaneAndlLineOff();// calling class
						
						
						
						Document curFamDoc=ActiveUIDocument.Document;
						curFamDoc.SaveAs(filenameOut);
						//curFamDoc.Close(); ///- too tedious to close open document
					}
					
				}}}
void refPlaneAndlLineOff()// this is called from refplane and turns off ref planesm ref lines and dims in a current view of the family
		{
			Document doc = ActiveUIDocument.Document;
			Autodesk.Revit.DB.View pView = doc.ActiveView;
			Autodesk.Revit.DB.Transaction t = new Autodesk.Revit.DB.Transaction(ActiveUIDocument.Document, "refplanesoff");
			t.Start();

			//get settings
			Settings docSettings = doc.Settings;
			//get all categories
			Categories allcats = docSettings.Categories;
			//this is a map, so I can use get
			Category refLines = allcats.get_Item(BuiltInCategory.OST_ReferenceLines);
			Category refPlanes = allcats.get_Item(BuiltInCategory.OST_CLines);
			Category dims = allcats.get_Item(BuiltInCategory.OST_Dimensions);

//			pView.SetVisibility(refPlanes, false);   setvisibility is deprecated
//			pView.SetVisibility(refLines, false);
//			pView.SetVisibility(dims, false);
			
			pView.SetCategoryHidden(refPlanes.Id, true);
			pView.SetCategoryHidden(refLines.Id, true);
			pView.SetCategoryHidden(dims.Id, true);
			///to zoom extent we need to get the view from UI
//
			UIView uiview = null;
			IList<UIView> uiviews = ActiveUIDocument.GetOpenUIViews();

			foreach (UIView uv in uiviews) {
				// find the active view in the interface
				if (uv.ViewId.Equals(pView.Id)) {
					uiview = uv;
					uiview.ZoomToFit();
					break;
				}
			}


			t.Commit();
		}
		
				
	}
}